VERSION 5.00
Begin VB.Form BrowseForFolerForm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Utilizzo avanzato di Browse for folders"
   ClientHeight    =   2055
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7335
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2055
   ScaleWidth      =   7335
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtSelected 
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Text            =   "Percorso selezionato"
      Top             =   1560
      Width           =   7095
   End
   Begin VB.CommandButton BrowseForFolders 
      Caption         =   "&Sfoglia cartelle"
      Height          =   375
      Left            =   5040
      TabIndex        =   1
      Top             =   480
      Width           =   2175
   End
   Begin VB.TextBox txtStart 
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Text            =   "Percorso di avvio"
      Top             =   480
      Width           =   4815
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Percorso selezionato:"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9.75
         Charset         =   177
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   150
      TabIndex        =   4
      Top             =   1245
      Width           =   1890
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Scrivi il percorso dal quale avviare il Browse for folder:"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9.75
         Charset         =   177
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   4605
   End
End
Attribute VB_Name = "BrowseForFolerForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Public Function BrowseForFolder(selectedPath As String) As String
    Dim Browse_for_folder As BROWSEINFOTYPE
    Dim itemID As Long
    Dim selectedPathPointer As Long
    Dim tmpPath As String * 256
    With Browse_for_folder
        .hOwner = Me.hWnd
        .lpszTitle = "Seleziona una cartella:" ' Titolo dialogo
        .lpfn = FunctionPointer(AddressOf BrowseCallbackProcStr) ' Funzione di callback per la preselezione cartella
        selectedPathPointer = LocalAlloc(LPTR, Len(selectedPath) + 1) ' Allocamento stringa
        CopyMemory ByVal selectedPathPointer, ByVal selectedPath, Len(selectedPath) + 1
        .lParam = selectedPathPointer ' Cartella preselezionata
    End With
    itemID = SHBrowseForFolder(Browse_for_folder) ' Apertura finestra di dialogo
    If itemID Then
        If SHGetPathFromIDList(itemID, tmpPath) Then
            BrowseForFolder = Left$(tmpPath, InStr(tmpPath, vbNullChar) - 1) ' Elimina gli spazi nulli
        End If
        Call CoTaskMemFree(itemID)
    End If
    Call LocalFree(selectedPathPointer)
End Function
Private Sub BrowseForFolders_Click()
    Dim tmpPath As String
    tmpPath = txtStart
    If Len(tmpPath) > 0 Then
        If Not Right$(tmpPath, 1) <> "\" Then tmpPath = Left$(tmpPath, Len(tmpPath) - 1) ' Remove "\" if the user added
    Else
        tmpPath = ""
    End If
    If Right(tmpPath, 1) = ":" Then tmpPath = tmpPath & "\"
    txtStart = tmpPath
    tmpPath = BrowseForFolder(tmpPath)
    If tmpPath = "" Then
        txtSelected = "Nessuna cartella selezionata."
    Else
        txtSelected = "Cartella selezionata: " & tmpPath
    End If
End Sub
